## com.saxonica.sdoc
Class SchemaElement

    java.lang.Object
      net.sf.saxon.tree.NodeImpl
          net.sf.saxon.tree.ElementImpl
              com.saxonica.sdoc.SchemaElement

All Implemented Interfaces:
  javax.xml.transform.Source, javax.xml.transform.SourceLocator, PullEvent, FingerprintedNode, Item, MutableNodeInfo, NamespaceResolver, NodeInfo, SiblingCountingNode, ValueRepresentation

Direct Known Subclasses:
  AnnotationParent, UnknownElement, XSDAnnotation, XSDAttribute, XSDAttributeGroup, XSDComplexContent, XSDComplexContentRestriction, XSDComplexType, XSDCompositor, XSDDocumentation, XSDElement, XSDExtension, XSDGroup, XSDIdentityConstraint, XSDList, XSDRedefine, XSDSchema, XSDSimpleContent, XSDSimpleContentRestriction, XSDSimpleType, XSDSimpleTypeRestriction, XSDUnion

    public abstract class SchemaElement

extends ElementImpl

An element in an XML Schema document. This is an abstract superclass for the elements in the schema document; many of its methods are designed to be called from the subclasses

Field Summary
`protected java.lang.Object` `children`
`static int` `REQUIRE_NULL_NS` Option indicating "no namespace prefix is allowed; the name is in the null Namespace"
`static int` `REQUIRE_TARGET_NS` Option indicating "no namespace prefix is allowed; the name is in the targetNamespace"
`protected int` `sequence`
`static int` `USE_DEFAULT_NS` Option indicating "use the default element namespace when unprefixed"

Fields inherited from class net.sf.saxon.tree.ElementImpl
`attributeList, nameCode, namespaceList, typeCode`

Fields inherited from class net.sf.saxon.tree.NodeImpl
`index, NODE_LETTER, parent`

Fields inherited from interface net.sf.saxon.om.NodeInfo
`ALL_NAMESPACES, EMPTY_NAMESPACE_LIST, IS_DTD_TYPE, IS_NILLED, LOCAL_NAMESPACES, NO_NAMESPACES`

Fields inherited from interface net.sf.saxon.om.NodeInfo
`ALL_NAMESPACES, EMPTY_NAMESPACE_LIST, IS_DTD_TYPE, IS_NILLED, LOCAL_NAMESPACES, NO_NAMESPACES`

Constructor Summary
`SchemaElement()` Construct a SchemaElement

Method Summary
`void` `addChild(NodeImpl node, int index)` Add a child node to this node.
`protected int` `allocateAnonymousTypeCode()` Allocate a name to an anonymous type.
`void` `allowAttributes(AttributeCollection atts, java.lang.String[] allowed)` Check the attributes of an element against a list of allowed attributes.
`protected void` `checkContentModel(int[][] stateTerms, int[][] stateTargets)` Check the content model of an element in the schema.
`protected void` `checkMutuallyExclusiveAttributes(java.lang.String name1, java.lang.String name2)` This method tests whether two attributes coexist and reports an error if they do
`protected void` `checkOnlyChildIsAnnotation()` Check that the only child element of this element is an (optional and non-repeatable) xs:annotation element
`void` `compact(int size)` Compact the space used by this node
`protected void` `duplicate(java.lang.String category, java.lang.String name)` This method is called when two objects in the same symbol space within a schema have duplicate names
`protected void` `duplicateElement(java.lang.String name)` This method is called when two occurrences of a child element are found and only one is allowed.
`protected AxisIterator` `enumerateChildren(NodeTest test)` Get an enumeration of the children of this node
`protected void` `error(SchemaException exception)` This method is called for a general error.
`protected void` `error(java.lang.String err)` This method is called for a general error.
`protected UserComplexType` `getContainingComplexType()` Get the complexType associated with the containing xs:complexType element
`protected SimpleTypeDefinition` `getContainingSimpleType()` Get the simpleTypeDefinition associated with the containing xs:simpleType element
`protected int` `getFingerprint(java.lang.String name, int option)` This method is called to check that a QName is valid and allocate a fingerprint for the name in the namePool.
`NodeInfo` `getFirstChild()` Get the first child node of the element
`NodeInfo` `getLastChild()` Get the last child node of the element
`protected int` `getNameCode(java.lang.String name, int option)` This method is called to check that a QName is valid and allocate a nameCode for the name in the namePool.
`protected NodeImpl` `getNthChild(int n)` Get the nth child node of the element (numbering from 0)
`int` `getNumberOfChildren()` Determine how many children the node has
`protected SingleNamespaceSchema` `getSchema()` Get the schema corresponding to the contents of the schema document containing this element
`SchemaNodeFactory` `getSchemaNodeFactory()` Get the nodeFactory used to create this element.
`protected long` `getSequenceNumber()` Get the node sequence number (in document order).
`java.lang.String` `getStringValue()` Return the string-value of the node, that is, the concatenation of the character content of all descendent elements and text nodes.
`java.lang.CharSequence` `getStringValueCS()` Get the value of the item as a CharSequence.
`protected XSDSchema` `getXSDSchema()` Get the owning XSDSchema element.
`boolean` `hasChildNodes()` Determine if the node has any children.
`protected void` `illegalElement(NodeInfo child)` This method is called when an illegal Element is encountered.
`protected java.lang.String` `indefiniteArticle(java.lang.String word, java.lang.String start)` Construct an indefinite article in English
`void` `insertChildren(NodeInfo[] source, boolean atStart, boolean inherit)` Insert copies of a sequence of nodes as children of this node.
`protected void` `insertChildrenAt(NodeInfo[] source, int index, boolean inherit)` Insert children before or after a given existing child
`void` `invalidAttributeValue(java.lang.String name, java.lang.String value, java.lang.String message)` This method is called when an invalid attribute value is found
`protected boolean` `isFinalState(int state)`
`protected boolean` `isTopLevel()` Return true if this element is a child of xs:schema or xs:redefine
`protected SavedNamespaceContext` `makeNamespaceContext()` Make a NamespaceContext object representing the list of in-scope namespaces.
`void` `missingAttribute(java.lang.String name)` This method is called when a required attribute is not found
`void` `missingChildElement(java.lang.String name)` This method is called when a required child element is not found
`protected void` `mustBeFirstElement(java.lang.String name)` This method is called when a child element is required to be the first child, but is found elsewhere
`void` `mustBeLastElement(java.lang.String name)` This method is called when a child element is required to be the first child, but is found elsewhere
`protected void` `mustPrecede(java.lang.String name1, java.lang.String name2)` This method is called when two child elements are found in the wrong order.
`protected void` `mutuallyExclusive(java.lang.String name1, java.lang.String name2)` This method is called when two child elements may not coexist
`protected void` `mutuallyExclusiveAttributes(java.lang.String name1, java.lang.String name2)` This method is called when two attributes may not coexist
`protected void` `mutuallyExclusiveElementAndAttribute(java.lang.String elem, java.lang.String att)` This method is called when an attribute and a child elements may not coexist
`int` `parseFinalOrBlock(java.lang.String attrName, java.lang.String finalValue, int allowed)` Parse a list of blocked or final derivations.
`void` `postValidate(SchemaCompiler compiler)` Hook to allow additional validation of a parent element immediately after its children have been validated.
`abstract void` `prepareAttributes()` Set the attribute list for the element.
`void` `processAllAttributes()` Process the attributes of this element and all its children
`void` `processId()` Process an @id attribute on the schema element: if present, check that it is a valid ID, and that it is unique in the schema document
`int` `processMaxOccurs(java.lang.String attValue)` Process the value of a maxOccurs attribute on any element where it appears
`int` `processMinOccurs(java.lang.String attValue)` Process the value of a minOccurs attribute on any element where it appears
`protected void` `removeChild(NodeImpl child)` Remove a given child
`protected void` `replaceChildrenAt(NodeInfo[] source, int index, boolean inherit)` Replace child at a given index by new children
`void` `requireAttribute(AttributeCollection atts, java.lang.String required)` Indicate that a particular attribute is required
`void` `setSchemaNodeFactory(SchemaNodeFactory factory)` Set the nodeFactory used to create this element.
`protected void` `useChildrenArray(NodeImpl[] array)` Supply an array to be used for the array of children.
`void` `validate(SchemaCompiler compiler)` Check that the schema element is valid.
`protected void` `validateChildren(SchemaCompiler compiler)` Validate the children of this node, recursively.
`void` `validateSubtree(SchemaCompiler compiler)` Recursive walk through the schema to validate all nodes
`protected void` `warning(java.lang.String err)` Report a warning

Methods inherited from class net.sf.saxon.tree.ElementImpl

`addNamespace, copy, delete, fixupInsertedNamespaces, generateId, getAttributeList, getAttributeValue, getAttributeValue, getBaseURI, getColumnNumber, getDeclaredNamespaces, getDocumentRoot, getInScopeNamespaceCodes, getLineNumber, getNameCode, getNodeKind, getPrefixForURI, getRoot, getSystemId, getTypeAnnotation, getURICodeForPrefix, getURICodeForPrefixCode, getURIForPrefix, initialise, isNilled, iteratePrefixes, putAttribute, removeAttribute, removeTypeAnnotation, rename, replaceStringValue, setLineAndColumn, setLocation, setNameCode, setNamespaceDeclarations, setSystemId, setTypeAnnotation`

Methods inherited from class net.sf.saxon.tree.NodeImpl

`atomize, compareOrder, equals, getConfiguration, getDisplayName, getDocumentNumber, getFingerprint, getLocalPart, getNamePool, getNextInDocument, getNextSibling, getParent, getPhysicalRoot, getPrefix, getPreviousInDocument, getPreviousSibling, getPublicId, getSiblingPosition, getTypedValue, getURI, hashCode, insertSiblings, isId, isIdref, isSameNodeInfo, iterateAxis, iterateAxis, newBuilder, replace`

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### USE_DEFAULT_NS

    public static final int USE_DEFAULT_NS

  Option indicating "use the default element namespace when unprefixed"

  See Also:
    Constant Field Values

### REQUIRE_TARGET_NS

    public static final int REQUIRE_TARGET_NS

  Option indicating "no namespace prefix is allowed; the name is in the targetNamespace"

  See Also:
    Constant Field Values

### REQUIRE_NULL_NS

    public static final int REQUIRE_NULL_NS

  Option indicating "no namespace prefix is allowed; the name is in the null Namespace"

  See Also:
    Constant Field Values

### children

    protected java.lang.Object children

### sequence

    protected int sequence

Constructor Detail

### SchemaElement

    public SchemaElement()

  Construct a SchemaElement

Method Detail

### isTopLevel

    protected boolean isTopLevel()

  Return true if this element is a child of xs:schema or xs:redefine

  Returns:
    true if this element is a child of xs:schema or xs:redefine

### setSchemaNodeFactory

    public void setSchemaNodeFactory(SchemaNodeFactory factory)

  Set the nodeFactory used to create this element.

  Parameters:
    `factory` - the schema node factory

### getSchemaNodeFactory

    public SchemaNodeFactory getSchemaNodeFactory()

  Get the nodeFactory used to create this element. This nodeFactory is used to keep track of any errors encountered during construction of the schema document

  Returns:
    factory the schema node factory

### processAllAttributes

    public void processAllAttributes()
                              throws SchemaException

  Process the attributes of this element and all its children

  Throws:
    `SchemaException`

### prepareAttributes

    public abstract void prepareAttributes()
                                    throws SchemaException

  Set the attribute list for the element. This is called to process the attributes (note the distinction from processAttributes in the superclass). Must be supplied in a subclass

  Throws:
    `SchemaException`

### allowAttributes

    public void allowAttributes(AttributeCollection atts,
                                java.lang.String[] allowed)
                         throws SchemaException

  Check the attributes of an element against a list of allowed attributes. Report an error if any extraneous attribute is present

  Parameters:
    `atts` - the attributes actually present
    `allowed` - the attributes that are allowed for this element. They must be listed in alphabetical order
  Throws:
    `SchemaException`

### requireAttribute

    public void requireAttribute(AttributeCollection atts,
                                 java.lang.String required)
                          throws SchemaException

  Indicate that a particular attribute is required

  Parameters:
    `atts` - the attribtue collection
    `required` - the local name of the required attribute, which must be in the null namespace
  Throws:
    `SchemaException`

### validateSubtree

    public void validateSubtree(SchemaCompiler compiler)
                         throws SchemaException

  Recursive walk through the schema to validate all nodes

  Parameters:
    `compiler` - used for error reporting
  Throws:
    `SchemaException`

### validateChildren

    protected void validateChildren(SchemaCompiler compiler)
                             throws SchemaException

  Validate the children of this node, recursively.

  Parameters:
    `compiler` - used for error reporting
  Throws:
    `SchemaException` - if the subtree is not valid

### validate

    public void validate(SchemaCompiler compiler)
                  throws SchemaException

  Check that the schema element is valid. This is called once for each element, after the entire tree has been built. As well as validation, it can perform first-time initialisation. The default implementation does nothing; it is normally overriden in subclasses.

  Parameters:
    `compiler` - used for error reporting
  Throws:
    `SchemaException` - if the subtree is not valid

### postValidate

    public void postValidate(SchemaCompiler compiler)
                      throws SchemaException

  Hook to allow additional validation of a parent element immediately after its children have been validated.

  Parameters:
    `compiler` - used for error reporting
  Throws:
    `SchemaException` - if errors are found

### getXSDSchema

    protected XSDSchema getXSDSchema()
                              throws SchemaException

  Get the owning XSDSchema element.

  Returns:
    the containing xs:schema element
  Throws:
    `SchemaException` - if none is found (which means the schema is invalid)

### getSchema

    protected SingleNamespaceSchema getSchema()
                                       throws SchemaException

  Get the schema corresponding to the contents of the schema document containing this element

  Returns:
    the PreparedSchema object used to assemble the schema components defined in the schema document that contains this element.
  Throws:
    `SchemaException` - if the containing PreparedSchema cannot be found

### getContainingComplexType

    protected UserComplexType getContainingComplexType()
                                                throws SchemaException

  Get the complexType associated with the containing xs:complexType element

  Returns:
    the UserComplexType object representing the containing complex type
  Throws:
    `SchemaException` - if the element is not contained in an xs:complexType

### getContainingSimpleType

    protected SimpleTypeDefinition getContainingSimpleType()
                                                    throws SchemaException

  Get the simpleTypeDefinition associated with the containing xs:simpleType element

  Returns:
    the schema component representing the containing simple type
  Throws:
    `SchemaException` - if not contained in an xs:simpleType

### makeNamespaceContext

    protected SavedNamespaceContext makeNamespaceContext()

  Make a NamespaceContext object representing the list of in-scope namespaces. The NamePool used for numeric codes in the NamespaceContext will be the target name pool.

  Returns:
    a copy of the namespace context for this element

### error

    protected void error(java.lang.String err)
                  throws SchemaException

  This method is called for a general error. The location of this message is the current element.

  Parameters:
    `err` - the error message to report
  Throws:
    `SchemaException`

### error

    protected void error(SchemaException exception)
                  throws SchemaException

  This method is called for a general error. The location of this message is the current element.

  Parameters:
    `exception` - the error message to report
  Throws:
    `SchemaException`

### warning

    protected void warning(java.lang.String err)

  Report a warning

  Parameters:
    `err` - the warning message

### getFingerprint

    protected int getFingerprint(java.lang.String name,
                                 int option)
                          throws SchemaException

  This method is called to check that a QName is valid and allocate a fingerprint for the name in the namePool. If the QName isn't valid, the method throws an exception: it is the caller's responsibility to call the error handler and recover from the error. The method makes use of the namespace context information for the schema element.

  Parameters:
    `name` - The QName
    `option` - The option for handling unprefixed names. Options are to use the default namespace, the target namespace, or the null namespace Note that this method assumes the name, if unprefixed, is in the default namespace: NOT the targetNamespace of the schema.
  Returns:
    a fingerprint
  Throws:
    `SchemaException` - if the QName is invalid.

### getNameCode

    protected int getNameCode(java.lang.String name,
                              int option)
                       throws SchemaException

  This method is called to check that a QName is valid and allocate a nameCode for the name in the namePool. If the QName isn't valid, the method throws an exception: it is the caller's responsibility to call the error handler and recover from the error. The method makes use of the namespace context information for the schema element.

  Parameters:
    `name` - The QName
    `option` - The option for handling unprefixed names. Options are to use the default namespace `USE_DEFAULT_NS`, the target namespace `REQUIRE_TARGET_NS`, or the null namespace `REQUIRE_NULL_NS`
  Returns:
    an integer name code
  Throws:
    `SchemaException` - if the QName is invalid.

### checkOnlyChildIsAnnotation

    protected void checkOnlyChildIsAnnotation()
                                       throws SchemaException

  Check that the only child element of this element is an (optional and non-repeatable) xs:annotation element

  Throws:
    `SchemaException`

### illegalElement

    protected void illegalElement(NodeInfo child)
                           throws SchemaException

  This method is called when an illegal Element is encountered.

  Parameters:
    `child` - The child element whose presence is an error
  Throws:
    `SchemaException` - thrown if the errorListener decides that it's a fatal error.

### duplicateElement

    protected void duplicateElement(java.lang.String name)
                             throws SchemaException

  This method is called when two occurrences of a child element are found and only one is allowed.

  Parameters:
    `name` - the name of the illegal element
  Throws:
    `SchemaException` - thrown if the errorListener decides that it's a fatal error.

### duplicate

    protected void duplicate(java.lang.String category,
                             java.lang.String name)
                      throws SchemaException

  This method is called when two objects in the same symbol space within a schema have duplicate names

  Parameters:
    `category` - the name of the first attribute
    `name` - the name of the second attribute
  Throws:
    `SchemaException` - thrown if the errorListener decides that it's a fatal error.

### mutuallyExclusive

    protected void mutuallyExclusive(java.lang.String name1,
                                     java.lang.String name2)
                              throws SchemaException

  This method is called when two child elements may not coexist

  Parameters:
    `name1` - the name of the first element
    `name2` - the name of the second element
  Throws:
    `SchemaException` - thrown if the errorListener decides that it's a fatal error.

### mutuallyExclusiveElementAndAttribute

    protected void mutuallyExclusiveElementAndAttribute(java.lang.String elem,
                                                        java.lang.String att)
                                                 throws SchemaException

  This method is called when an attribute and a child elements may not coexist

  Parameters:
    `elem` - the name of the element
    `att` - the name of the attribute
  Throws:
    `SchemaException` - thrown if the errorListener decides that it's a fatal error.

### mutuallyExclusiveAttributes

    protected void mutuallyExclusiveAttributes(java.lang.String name1,
                                               java.lang.String name2)
                                        throws SchemaException

  This method is called when two attributes may not coexist

  Parameters:
    `name1` - the name of the first attribute
    `name2` - the name of the second attribute
  Throws:
    `SchemaException` - thrown if the errorListener decides that it's a fatal error.

### checkMutuallyExclusiveAttributes

    protected void checkMutuallyExclusiveAttributes(java.lang.String name1,
                                                    java.lang.String name2)
                                             throws SchemaException

  This method tests whether two attributes coexist and reports an error if they do

  Parameters:
    `name1` - the local name of the first attribute (must be in the null namespace)
    `name2` - the local name of the second attribute (must be in the null namespace)
  Throws:
    `SchemaException`

### mustPrecede

    protected void mustPrecede(java.lang.String name1,
                               java.lang.String name2)
                        throws SchemaException

  This method is called when two child elements are found in the wrong order.

  Parameters:
    `name1` - the name of the element that should be first
    `name2` - the name of the element that should be second
  Throws:
    `SchemaException` - thrown if the errorListener decides that it's a fatal error.

### mustBeFirstElement

    protected void mustBeFirstElement(java.lang.String name)
                               throws SchemaException

  This method is called when a child element is required to be the first child, but is found elsewhere

  Parameters:
    `name` - the name of the illegal element
  Throws:
    `SchemaException` - thrown if the errorListener decides that it's a fatal error.

### indefiniteArticle

    protected java.lang.String indefiniteArticle(java.lang.String word,
                                                 java.lang.String start)

  Construct an indefinite article in English

  Parameters:
    `word` - The word to follow the article
    `start` - Typically "a" or "A"
  Returns:
    the indefinite article

### mustBeLastElement

    public void mustBeLastElement(java.lang.String name)
                           throws SchemaException

  This method is called when a child element is required to be the first child, but is found elsewhere

  Parameters:
    `name` - the name of the illegal element
  Throws:
    `SchemaException` - thrown if the errorListener decides that it's a fatal error.

### invalidAttributeValue

    public void invalidAttributeValue(java.lang.String name,
                                      java.lang.String value,
                                      java.lang.String message)
                               throws SchemaException

  This method is called when an invalid attribute value is found

  Parameters:
    `name` - the name of the attribute
    `value` - the supplied value of the attribute
    `message` - additional explanation of why it's wrong. May be null.
  Throws:
    `SchemaException` - thrown if the errorListener decides that it's a fatal error.

### missingAttribute

    public void missingAttribute(java.lang.String name)
                          throws SchemaException

  This method is called when a required attribute is not found

  Parameters:
    `name` - the name of the attribute
  Throws:
    `SchemaException` - thrown if the errorListener decides that it's a fatal error.

### missingChildElement

    public void missingChildElement(java.lang.String name)
                             throws SchemaException

  This method is called when a required child element is not found

  Parameters:
    `name` - the name of the required child element
  Throws:
    `SchemaException` - thrown if the errorListener decides that it's a fatal error.

### parseFinalOrBlock

    public int parseFinalOrBlock(java.lang.String attrName,
                                 java.lang.String finalValue,
                                 int allowed)
                          throws SchemaException

  Parse a list of blocked or final derivations. Used to process the block, final, blockDefault, and finalDefault attributes.

  Parameters:
    `attrName` - the name of the attribute being parsed
    `finalValue` - A list of values to be parsed, as a string, for example "extension restriction"
    `allowed` - The permitted values, as a bit-significant integer. For example the value (DERIVE_BY_EXTENSION | DERIVE_BY_RESTRICTION) allows the values "extension" and "restriction" to appear.
  Returns:
    The final/blocked values, as a bit-significant integer
  Throws:
    `SchemaException`

### processId

    public void processId()
                   throws SchemaException

  Process an @id attribute on the schema element: if present, check that it is a valid ID, and that it is unique in the schema document

  Throws:
    `SchemaException` - if the id is present and is invalid or is a duplicate

### allocateAnonymousTypeCode

    protected int allocateAnonymousTypeCode()

  Allocate a name to an anonymous type. It's important that the name allocated should be repeatable, because it can be referenced as a type annotation in a PTree document.

  Returns:
    the name code of the allocated name

### processMaxOccurs

    public int processMaxOccurs(java.lang.String attValue)
                         throws SchemaException

  Process the value of a maxOccurs attribute on any element where it appears

  Parameters:
    `attValue` - the value of the attribute as written, either "unbounded" or an integer
  Returns:
    the value of the attribute as an integer, or -1 indicating "unbounded"
  Throws:
    `SchemaException` - if the value is invalid (in which case the error will have been reported). If the value is a very high integer (greater than Integer.MAX_VALUE), the method outputs a warning and treats the value as "unbounded".

### processMinOccurs

    public int processMinOccurs(java.lang.String attValue)
                         throws SchemaException

  Process the value of a minOccurs attribute on any element where it appears

  Parameters:
    `attValue` - the value of the attribute as written, an integer
  Returns:
    the value of the attribute as an integer
  Throws:
    `SchemaException` - if the value is invalid (in which case the error will have been reported). If the value is a very high integer (greater than Integer.MAX_VALUE), the method outputs a warning and treats the value as Integer.MAX_VALUE.

### checkContentModel

    protected void checkContentModel(int[][] stateTerms,
                                     int[][] stateTargets)
                              throws SchemaException

  Check the content model of an element in the schema. This uses a finite state machine generated into the Java source code by applying an XSLT transformation to the schema component model for the Schema for Schemas.

  The finite state machine is generated as follows: First process the S4S to create an SCM model, then apply the stylesheet generate-S4S-code in the build directory with type=complexType

  Parameters:
    `stateTerms` - an array of states, and for each state, an array containing the fingerprints of elements allowed to appear in that state
    `stateTargets` - an array of states, and for each state, an array containing the destinations of transitions when the corresponding term from stateTerms is encountered
  Throws:
    `SchemaException` - if the schema being processed does not conform to the required content model

### isFinalState

    protected boolean isFinalState(int state)

### getSequenceNumber

    protected final long getSequenceNumber()

  Get the node sequence number (in document order). Sequence numbers are monotonic but not consecutive. In the current implementation, parent nodes (elements and document nodes) have a zero least-significant word, while namespaces, attributes, text nodes, comments, and PIs have the top word the same as their owner and the bottom half reflecting their relative position. For nodes added by XQUery Update, the sequence number is -1L

  Overrides:
    `getSequenceNumber` in class `NodeImpl`
  Returns:
    the sequence number if there is one, or -1L otherwise.

### hasChildNodes

    public final boolean hasChildNodes()

  Determine if the node has any children.

  Specified by:
    `hasChildNodes` in interface `NodeInfo`
  Overrides:
    `hasChildNodes` in class `NodeImpl`
  Returns:
    `true` if the node has any children, `false` if the node has no children.

### getNumberOfChildren

    public int getNumberOfChildren()

  Determine how many children the node has

  Returns:
    the number of children of this parent node

### enumerateChildren

    protected final AxisIterator enumerateChildren(NodeTest test)

  Get an enumeration of the children of this node

  Parameters:
    `test` - A NodeTest to be satisfied by the child nodes, or null if all child node are to be returned
  Returns:
    an iterator over the children of this node

### getFirstChild

    public final NodeInfo getFirstChild()

  Get the first child node of the element

  Overrides:
    `getFirstChild` in class `NodeImpl`
  Returns:
    the first child node of the required type, or null if there are no children

### getLastChild

    public final NodeInfo getLastChild()

  Get the last child node of the element

  Overrides:
    `getLastChild` in class `NodeImpl`
  Returns:
    the last child of the element, or null if there are no children

### getNthChild

    protected final NodeImpl getNthChild(int n)

  Get the nth child node of the element (numbering from 0)

  Parameters:
    `n` - identifies the required child
  Returns:
    the last child of the element, or null if there is no n'th child

### removeChild

    protected void removeChild(NodeImpl child)

  Remove a given child

  Parameters:
    `child` - the child to be removed

### getStringValue

    public java.lang.String getStringValue()

  Return the string-value of the node, that is, the concatenation of the character content of all descendent elements and text nodes.

  Returns:
    the accumulated character content of the element, including descendant elements.
  See Also:
    `Item.getStringValueCS()`

### getStringValueCS

    public java.lang.CharSequence getStringValueCS()

  Description copied from class: `NodeImpl`
  Get the value of the item as a CharSequence. This is in some cases more efficient than the version of the method that returns a String.

  Specified by:
    `getStringValueCS` in interface `Item`
  Specified by:
    `getStringValueCS` in interface `ValueRepresentation`
  Overrides:
    `getStringValueCS` in class `NodeImpl`
  Returns:
    the string value of the item
  See Also:
    `Item.getStringValue()`

### useChildrenArray

    protected void useChildrenArray(NodeImpl[] array)

  Supply an array to be used for the array of children. For system use only.

  Parameters:
    `array` - the array to be used

### addChild

    public void addChild(NodeImpl node,
                         int index)

  Add a child node to this node. For system use only. Note: normalizing adjacent text nodes is the responsibility of the caller.

  Parameters:
    `node` - the node to be added as a child of this node
    `index` - the position where the child is to be added

### insertChildren

    public void insertChildren(NodeInfo[] source,
                               boolean atStart,
                               boolean inherit)

  Insert copies of a sequence of nodes as children of this node.

  This method takes no action unless the target node is a document node or element node. It also takes no action in respect of any supplied nodes that are not elements, text nodes, comments, or processing instructions.

  The supplied nodes will be copied to form the new children. Adjacent text nodes will be merged, and zero-length text nodes removed.

  Specified by:
    `insertChildren` in interface `MutableNodeInfo`
  Overrides:
    `insertChildren` in class `NodeImpl`
  Parameters:
    `source` - the nodes to be inserted
    `atStart` - true if the new nodes are to be inserted before existing children; false if they are
    `inherit` - true if the inserted nodes are to inherit the namespaces that are in-scope for their new parent; false if such namespaces should be undeclared on the children

### insertChildrenAt

    protected void insertChildrenAt(NodeInfo[] source,
                                    int index,
                                    boolean inherit)

  Insert children before or after a given existing child

  Parameters:
    `source` - the children to be inserted
    `index` - the position before which they are to be inserted: 0 indicates insertion before the first child, 1 insertion before the second child, and so on.
    `inherit` - true if the inserted nodes are to inherit the namespaces that are in-scope for their new parent; false if such namespaces should be undeclared on the children

### replaceChildrenAt

    protected void replaceChildrenAt(NodeInfo[] source,
                                     int index,
                                     boolean inherit)

  Replace child at a given index by new children

  Parameters:
    `source` - the children to be inserted
    `index` - the position at which they are to be inserted: 0 indicates replacement of the first child, replacement of the second child, and so on. The effect is undefined if index is out of range
    `inherit` - set to true if the new child elements are to inherit the in-scope namespaces of their new parent
  Throws:
    `java.lang.IllegalArgumentException` - if any of the replacement nodes is not an element, text, comment, or processing instruction node

### compact

    public void compact(int size)

  Compact the space used by this node

  Parameters:
    `size` - the number of actual children

Copyright (c) Saxonica Limited. All rights reserved.